/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2002-2008 by Y.D.K Co.,Ltd
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: xps_timer.c 1433 2009-01-21 15:43:24Z ydkinc-matsumoto $
 */

/*
 *  ޥɥ饤СXPS Timer/Counter
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "target_timer.h"
 
/*
 *  ޤεư
 */
void
target_timer_initialize(intptr_t exinf)
{
	CLOCK    cyc = TO_CLOCK(TIC_NUME, TIC_DENO);

	/*
	 *  ޼ꤷޤư򳫻Ϥ롥
	 */

	/*
	 * ߡߥꥢ
	 */
	sil_wrw_mem((void*)XTIMER_TCSR0, XTIMER_TCSR_INT_BIT);

	/* ޾ͤΥå */
	assert(cyc <= MAX_CLOCK);

	/* ͥå */
	sil_wrw_mem((void*)XTIMER_TLR0, cyc);

	/*
	 * ͥ
	 */
	sil_wrw_mem((void*)XTIMER_TCSR0, XTIMER_TCSR_LOAD_BIT);

	/*
	 * 0֥͡롤ߵġȥɡ󥫥ȡ
	 * ͥ⡼ 
	 */
	sil_wrw_mem((void*)XTIMER_TCSR0,
				(XTIMER_TCSR_ENT_BIT | XTIMER_TCSR_ENIT_BIT |
				  XTIMER_TCSR_ARHT_BIT |
				   XTIMER_TCSR_UDT_BIT));
}

/*
 *  ޤ߽
 */
void
target_timer_terminate(intptr_t exinf)
{
	/*
	 * ߡߥꥢ
	 */
	sil_wrw_mem((void*)XTIMER_TCSR0, XTIMER_TCSR_INT_BIT);
}

/*
 *  ޳ߥϥɥ
 */
void
target_timer_handler(void)
{
	/* ׵򥯥ꥢ */
	sil_wrw_mem((void*)XTIMER_TCSR0, sil_rew_mem((void*)XTIMER_TCSR0));
    
	i_begin_int(INTNO_TIMER);
	/* ƥåζ */
	signal_time();              
	i_end_int(INTNO_TIMER);
}
